//
// Created by Daniil Oreshnikov on 31.10.2024.
//

#include "testlib.h"
#include <vector>

using namespace std;

int main(int argc, char *argv[]) {

    registerInteraction(argc, argv);

    int n = inf.readInt();
    auto c = inf.readInts(2 * n);

    int a = 0, b = 0;
    while (c[a] == c[b]) {
        a = rnd.next(2 * n);
        b = rnd.next(2 * n);
    }
    if (c[a] > c[b]) swap(a, b);

    cout << n << ' ' << a + 1 << ' ' << b + 1 << '\n';
    cout.flush();

    int steps = 0, out = 0;
    vector<int> used(2 * n);
    while (out < n) {
        if (++steps >= 2 * n) {
            tout << -1 << '\n';
            quitf(_wa, "too many queries");
        }

        int x = ouf.readInt(1, 2 * n, "x") - 1;
        int y = ouf.readInt(1, 2 * n, "y") - 1;
        if (used[x] || used[y]) {
            tout << -1 << '\n';
            quitf(_wa, "invalid query, used card");
        }
        if (x == y) {
            tout << -1 << '\n';
            quitf(_wa, "invalid query, same card");
        }
        if (c[x] == c[y]) {
            used[x] = 1;
            used[y] = 1;
            out++;
        }

        cout << c[x] << ' ' << c[y] << '\n';
        cout.flush();
    }

    tout << 0 << '\n';

}