#include "testlib.h"

using namespace std;

const double INF = 1000'000;
const double DELTA = 1e-3;

void check(InStream &in, double x, double y) {
    double ansx = in.readDouble(-INF, INF, "x");
    double ansy = in.readDouble(-INF, INF, "y");

    in.ensuref(__testlib_abs(ansx - x) <= DELTA && __testlib_abs(ansy - y) <= DELTA, "position of hero differ: errors %lf and %lf", __testlib_abs(ansx - x), __testlib_abs(ansy - y));
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    inf.readDouble();
    double x = inf.readDouble();
    double y = inf.readDouble();

    check(ans, x, y);
    check(ouf, x, y);

    quitf(_ok, "Answers match");

}