#include "testlib.h"
#include <iomanip>

using namespace std;

typedef long double ld;

const double INF = 1000'000;
const int MAX_QUERIES = 400;

void send(bool a) {
	cout << (a ? "YES" : "NO") << endl;
   	fflush(stdout);
}

ld dist(ld x1, ld y1, ld x2, ld y2) {
    ld x = (x1 - x2);
    ld y = (y1 - y2);
    return x * x + y * y;
}

int main(int argc, char* argv[]) {
    registerInteraction(argc, argv);
    
    ld r = inf.readDouble();
    ld x = inf.readDouble();
    ld y = inf.readDouble();

    int queries = 0;
	while (true) 
	{
		string cur = ouf.readToken("!|?");
    	bool is_answer = cur == "!";

        ld xin = ouf.readDouble(-INF, INF, "x");
        ld yin = ouf.readDouble(-INF, INF, "y");

    	if (is_answer) {
            tout << std::fixed << std::setprecision(10) << xin << ' ' << yin << endl;
            quitf(_ok, "interaction ok with %d queries", queries);
    	} else if (++queries > MAX_QUERIES) {
            quitf(_wa, "queries limit exceeded (%d)", queries);
        }

        send(dist(x, y, xin, yin) <= 4 * r * r);
    }                  
}
