#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

double dist(double x1, double y1, double x2, double y2) {
    double x = (x1 - x2);
    double y = (y1 - y2);
    return x * x + y * y;
}

const double max_d = 100'000;
const double max_x = 100'000;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    double d = inf.readDouble(1, max_d, "d");
    inf.readEoln();

    double x = inf.readDouble(-max_x, max_x, "x");
    inf.readSpace();
    double y = inf.readDouble(-max_x, max_x, "y");
    inf.readEoln();

    inf.readEof();

    ensuref(dist(x, y, 0, 0) <= d * d, "start position (0, 0) should with distance not greater than d from (x, y)");
}