using namespace std;

#include <iostream>
#include <iomanip>
#include <vector>
#include <queue>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <functional>
#define X first
#define Y second

using ll = long long;
using ld = long double;

const double DIFF = 1e-16;
const double MAX = 1e6;

bool ask(ld x, ld y) {
    cout << "? " << x << " " << y << "\n";
    cout.flush();

    string s;
    cin >> s;
    return s == "YES";
}

int main() {
    cout.precision(10);
    cout << fixed;

    vector<pair<ld, ld>> points(1);
    for (auto e : { make_pair(0, 1), make_pair(1, 0), make_pair(1, 1) }) {
        ld lb = 0;
        ld rb = MAX;
//        int cnt = 0;
        for (int ii = 0; ii < 100; ++ii) {
//        while (rb - lb > DIFF) {
//            cnt++;
            ld m = (rb + lb) / 2;
            ld x = e.first * m;
            ld y = e.second * m;
            if (ask(x, y)) {
                lb = m;
            } else {
                rb = m;
            }
        }
        points.emplace_back(lb * e.first, lb * e.second);
    }
    for (int ii = 0; ii < 100; ++ii) {
        ask(ii, ii);
    }

    ld m1 = (points[2].Y - points[1].Y) / (points[2].X - points[1].X);
    ld m2 = (points[3].Y - points[2].Y) / (points[3].X - points[2].X);

    ld x = (
            m1 * m2 * (points[1].Y - points[3].Y) +
            m2 * (points[1].X + points[2].X) -
            m1 * (points[2].X + points[3].X)
            )/(2 * (m2 - m1));

    ld y;
    if (abs(m1) < 1e-3) {
        y = -1 / m2 * (x - (points[2].X + points[3].X) / 2) + (points[2].Y  + points[3].Y) / 2;
    } else {
        y = -1 / m1 * (x - (points[1].X + points[2].X) / 2) + (points[1].Y  + points[2].Y) / 2;
    }

    cout << "! " << x << " " << y << "\n";
}