#include "testlib.h"

using ll = long long;

bool is_prime(ll x) {
    for (ll i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            return false;
        }
    }
    return true;
}

const int max_tests = 10, max_val = 1e9;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int tests = inf.readInt(1, max_tests, "tests");
    inf.readEoln();
    for (int test = 1; test <= tests; test++) {
        setTestCase(test);
        int x = inf.readInt(1, max_val, "x_i");
        inf.readSpace();
        int y = inf.readInt(1, max_val, "y_i");
        inf.readSpace();
        int k = inf.readInt(1, max_val, "k_i");
        inf.readEoln();

        ensure(!is_prime(x + y));
    }
    inf.readEof();

    return 0;
}
