#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

using namespace std;

typedef long long ll;

const int MAX_L = 1000000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n;

    const int max_n = opt<int>("n");
    const int max_a = opt<int>("a");

    if (has_opt("fixn")) {
        opt<bool>("fixn");
        n = max_n;
    } else {
        n = 1 + rnd.wnext(max_n, 10);
    }

    vector<int> a(n);

    string mode = !has_opt("m") ? "rnd" : opt<string>("m");
    if (mode == "rnd") {
        for (int i = 0; i < n; ++i) {
           a[i] = rnd.next(0, max_a);
        }
    } else if (mode == "ord" && rnd.next(0, 1)) {
        int inc = max_a / n;
        for (int i = 1; i < n; ++i) {
            a[i] = a[i - 1] + inc;
        }
    } else if (mode == "ord") {
        int inc = max_a / n;
        for (int i = n - 2; i >= 0; --i) {
            a[i] = a[i + 1] + inc;
        }
    } else if (mode == "med") {
        vector<int> b(n);
        for (int i = 0; i < n; ++i) {
            b[i] = rnd.next(0, max_a);
        }
        sort(b.begin(), b.end());
        for (int i = 0; i < (n + 1) / 2; ++i) {
            a[i] = b[i * 2];
            a[n - 1 - i] = b[i * 2 + 1];
        }
    }

    println(n);
    println(a);

    return 0;
}
