using namespace std;

#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <algorithm>
#include <functional>
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr)
#define X first
#define Y second

using ll = long long;

const ll MOD = 1000000007;

ll modsum(ll a, ll b) {
    return (a + b) % MOD;
}

struct SegTree {
    typedef ll value_t;
    value_t neitral_v = 0;

    value_t sum_f(value_t a, value_t b) {
        return modsum(a, b);
    }

    SegTree(int n) : nn(pow(2, floor(log2(n - 1)) + 1)), ar(nn * 2, neitral_v) {
        for (int i = 0; i < n; ++i) {
            ar[nn - 1 + i] = 0;
        }
        for (int i = nn - 2; i >= 0; --i) {
            ar[i] = sum_f(ar[i * 2 + 1], ar[i * 2 + 2]);
        }
    }

    value_t ssum(int l, int r) {
        return ssum(l, r, 0, 0, nn);
    }

    value_t ssum(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return neitral_v;
        }
        if (l <= lx && rx <= r) {
            return ar[x];
        }
        int m = (lx + rx) / 2;
        return sum_f(ssum(l, r, x * 2 + 1, lx, m), ssum(l, r, x * 2 + 2, m, rx));
    }

    void sset(int l, value_t v) {
        sset(l, l + 1, 0, 0, nn, v);
    }

    void sset(int l, int r, value_t v) {
        sset(l, r, 0, 0, nn, v);
    }

    void sset(int l, int r, int x, int lx, int rx, value_t v) {
        if (l <= lx && rx <= r) {
            ar[x] = v;
            return;
        }
        if (l >= rx || r <= lx) {
            return;
        }
        int m = (lx + rx) / 2;
        sset(l, r, x * 2 + 1, lx, m, v);
        sset(l, r, x * 2 + 2, m, rx, v);
        ar[x] = sum_f(ar[x * 2 + 1], ar[x * 2 + 2]);
    }

    int nn;
    vector<value_t> ar;
};

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    map<int, int> compress;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        compress[a[i]] = 0;
    }

    if (n == 1) {
        cout << 1 << "\n";
        return 0;
    }

    int compressc = 0;
    for (auto& e : compress) {
        e.second = compressc++;
    }

    SegTree leftst(n);
    vector<ll> leftg(n);
    for (int i = 0; i < n; ++i) {
        leftg[i] = modsum(1, leftst.ssum(0, compress[a[i]]));
        leftst.sset(compress[a[i]], modsum(leftst.ssum(compress[a[i]], compress[a[i]] + 1), leftg[i]));
    }

    SegTree rightst(n);
    vector<ll> rightg(n);
    for (int i = n - 1; i >= 0; --i) {
        rightg[i] = 1 + rightst.ssum(0, compress[a[i]]);
        rightst.sset(compress[a[i]], modsum(rightst.ssum(compress[a[i]], compress[a[i]] + 1), rightg[i]));
    }

    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = modsum(ans, leftg[i] * rightg[i]);
//        cout << leftg[i] << " " << rightg[i] << "\n";
    }
    cout << ans << "\n";
//    cout << "\n";
//    cout << "\n";

    //    cout << "! " << x << " " << y << "\n";
    return 0;
}