#include "testlib.h"
#include <vector>
#include <unordered_set>

using namespace std;

int n, m, start;
vector<vector<int>> g;
vector<unordered_set<int>> portals;
unordered_set<int> allp;

void dfs(unordered_set<int> const &allowed, vector<int> &vis, int v) {
    if (!allowed.count(v)) return;
    vis[v] = 1;
    for (int u : g[v]) {
        if (!vis[u]) dfs(allowed, vis, u);
    }
}

int check(InStream &in) {
    int b = in.readInt(0, n, "b");
    auto bs = in.readInts(b, 1, n, "bs");

    in.ensuref(set<int>(bs.begin(), bs.end()).size() == b, "cities should not repeat");
    unordered_set<int> vert(allp.begin(), allp.end());
    for (int bi : bs) {
        in.ensuref(!allp.count(bi - 1), "city from portal should not be marked");
        vert.insert(bi - 1);
    }

    vector<int> vis(n);
    dfs(vert, vis, start);
    for (int v : allp) {
        in.ensuref(vis[v], "not all portal cities are reachable");
    }
    return b;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    m = inf.readInt();
    g.resize(n);
    portals.resize(3);

    for (int i = 0; i < 3; i++) {
        int k = inf.readInt();
        auto a = inf.readInts(k);
        for (int ai : a) {
            ai--;
            portals[i].insert(ai);
            allp.insert(ai);
            start = ai;
        }
    }

    for (int i = 0; i < m; i++) {
        int u = inf.readInt() - 1, v = inf.readInt() - 1;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    int ja = check(ans), pa = check(ouf);
    if (ja > pa) quitf(_fail, "participant found a better answer");
    if (ja < pa) quitf(_ok, "jury has a better answer");
    quitf(_ok, "answer matches");

}