#include "testlib.h"
#include <vector>
#include <unordered_set>

using namespace std;

int n, m, start;
vector<vector<int>> g;
vector<vector<int>> a;
unordered_set<int> allp;

void dfs(unordered_set<int> const &allowed, vector<int> &vis, int v) {
    if (!allowed.count(v)) return;
    vis[v] = 1;
    for (int u : g[v]) {
        if (!vis[u]) dfs(allowed, vis, u);
    }
}

void validateGraph(vector<int> const &vert, string const &name) {
    unordered_set<int> allowed(vert.begin(), vert.end());
    vector<int> vis(n);
    dfs(allowed, vis, vert[0]);
    for (int v : vert) {
        ensuref(vis[v], "%s: not connected", name.c_str());
    }
}

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    n = inf.readInt(1, 200'000, "n");
    inf.readSpace();
    m = inf.readInt(1, 200'000, "m");
    inf.readEoln();

    a.resize(3);
    for (int i = 0; i < 3; i++) {
        int k = inf.readInt(1, n, format("k_%d", i + 1));
        inf.readEoln();

        a[i] = inf.readInts(k, 1, n, format("a_%d", i + 1));
        for (int &ai: a[i]) {
            ai--;
            ensuref(!allp.count(ai), "repeated portal city");
            allp.insert(ai);
        }
        inf.readEoln();
    }

    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u = inf.readInt(1, n, format("u_%d", i + 1)) - 1;
        inf.readSpace();
        int v = inf.readInt(1, n, format("v_%d", i + 1)) - 1;
        inf.readEoln();

        g[u].push_back(v);
        g[v].push_back(u);
    }

    validateGraph(a[0], "portal 1");
    validateGraph(a[1], "portal 2");
    validateGraph(a[2], "portal 3");
    vector<int> seq(n);
    for (int i = 0; i < n; i++) {
        seq[i] = i;
    }
    validateGraph(seq, "all graph");

    inf.readEof();

}
