/*
Author: @doreshnikov
Created on: 01.11.2024/21:17
*/

#include <iostream>
#include <vector>
#include <deque>
#include <unordered_set>

using namespace std;

typedef unsigned long long ull;
typedef unsigned int uint;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}

#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

typedef vector<vector<int>> graph;

int n, m;
graph g;
vector<vector<int>> a;

int main() {

    cin >> n >> m;
    g.resize(n);
    a.resize(3);

    for (int i = 0; i < 3; i++) {
        in(int, k)
        a[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }

    for (int i = 0; i < m; i++) {
        in(int, u, v)
        g[--u].push_back(--v);
        g[v].push_back(u);
    }

    vector<vector<int>> dist(3), back(3);
    for (int i = 0; i < 3; i++) {
        auto &d = dist[i];
        auto &b = back[i];
        d.assign(n, n + 1);
        b.assign(n, -1);
        deque<int> q;

        for (int ai : a[i]) {
            q.push_back(ai);
            d[ai] = 0;
        }

        while (!q.empty()) {
            int v = q.front();
            q.pop_front();

            for (int u : g[v]) {
                if (d[u] > d[v] + 1) {
                    d[u] = d[v] + 1;
                    q.push_back(u);
                    b[u] = v;
                }
            }
        }
    }

    int ans = 3 * n;
    vector<pair<int, int>> paths;
    for (int i = 0; i < 3; i++) {
        int total = 0;
        vector<int> targets;

        for (int j = 0; j < 3; j++) {
            if (i == j) continue;
            int mn = n + 1, target = -1;
            for (int v : a[j]) {
                if (dist[i][v] < mn) {
                    mn = dist[i][v];
                    target = v;
                }
            }
            total += mn - 1;
            targets.push_back(target);
        }

        if (total < ans) {
            ans = total;
            paths.clear();
            for (int v : targets) {
                paths.emplace_back(i, back[i][v]);
            }
        }
    }

    for (int v = 0; v < n; v++) {
        int total = dist[0][v] + dist[1][v] + dist[2][v] - 2;
        if (total < ans) {
            ans = total;
            paths = {{0, v}, {1, v}, {2, v}};
        }
    }

    unordered_set<int> result;
    for (auto const &[i, v] : paths) {
        int cur = v;
        while (dist[i][cur] > 0) {
            result.insert(cur);
            cur = back[i][cur];
        }
    }

    cout << ans << '\n';
    for (int v : result) {
        cout << v + 1 << ' ';
    }
    cout << '\n';

}