#include "jngen.h"
#include <iostream>
#include <string>

using std::cout;

const int MAX_N = 2 * 100'000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    parseArgs(argc, argv);

    int n = getOpt("n", MAX_N);
    int distinct_colors = getOpt("k");

    auto colors =
            TArray<int>::randomUnique(distinct_colors, 1, n)
            .choiceWithRepetition(n);

    cout << n << "\n";
    cout << colors << "\n";

    std::string graph_type = getOpt("type", "random");
    Tree tree;

    if (graph_type == "random") {
        tree = Tree::random(n);
    } else if (graph_type == "prim") {
        int elong = getOpt("elong", 0);
        tree = Tree::randomPrim(n, elong);
    } else if (graph_type == "kruskal") {
        tree = Tree::randomKruskal(n);
    } else if (graph_type == "bamboo") {
        tree = Tree::bamboo(n);
    } else if (graph_type == "star") {
        tree = Tree::star(n);
    } else if (graph_type == "cater") {
        int len = getOpt("len");
        tree = Tree::caterpillar(n, len);
    } else if (graph_type == "kary") {
        int k = getOpt("deg", 2);
        tree = Tree::kary(n, k);
    }
    tree.shuffle();
    if (n != 1) {
        cout << tree.add1() << "\n";
    }
}
