#include <vector>
#include "testlib.h"

using std::vector;

const size_t MAX_N = 2 * 100'000;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(1, MAX_N, "n");
    inf.readEoln();
    inf.readInts(n, 1, n, "k_i");
    inf.readEoln();

    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
        int v = inf.readInt(1, n, "v");
        inf.readSpace();
        int u = inf.readInt(1, n, "u");
        inf.readEoln();

        g[v - 1].push_back(u - 1);
        g[u - 1].push_back(v - 1);
    }
    inf.readEof();
    vector<bool> used(n, false);

    std::function<void(int)> dfs = [&](int v) {
        used[v] = true;
        for (auto u : g[v]) {
            if (!used[u]) {
                dfs(u);
            }
        }
    };
    dfs(0);

    for (int i = 0; i < n; i++) {
        ensuref(used[i], "node %d is not reachable from node 1\n", i + 1);
    }
    return 0;
}