#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> colors;

void validate_set(int v, vector<bool> &may_visit, set<int> &used_c) {
    may_visit[v] = false;
    used_c.insert(colors[v]);
    for (int u : g[v]) {
        if (may_visit[u]) {
            validate_set(u, may_visit, used_c);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    colors.resize(n);
    for (auto &c : colors) {
        cin >> c;
        c--;
    }
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> dp(1 << n, n + 1);
    dp[0] = 0;
    vector<int> used_submask(1 << n);
    for (int mask = 1; mask < (1 << n); mask++) {
        int submask = mask;
        while (submask > 0) {
            vector<bool> may_visit(n, false);
            int root;
            for (int v = 0; v < n; v++) {
                if (submask & (1 << v)) {
                    root = v;
                    may_visit[v] = true;
                }
            }
            set<int> colors_used;
            validate_set(root, may_visit, colors_used);
            if (std::count(may_visit.begin(), may_visit.end(), true) == 0 &&
                colors_used.size() <= 2 &&
                dp[mask] > 1 + dp[mask ^ submask]) {
                dp[mask] = 1 + dp[mask ^ submask];
                used_submask[mask] = submask;
            }
            submask = (submask - 1) & mask;
        }
    }
    cout << dp[(1 << n) - 1] << "\n";
    int mask = (1 << n) - 1;
    while (mask != 0) {
        int submask = used_submask[mask];
        cout << __builtin_popcount(submask);
        for (int v = 0; v < n; v++) {
            if (submask & (1 << v)) {
                cout << " " << v + 1;
            }
        }
        cout << "\n";
        mask ^= submask;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}
