#include <bits/stdc++.h>

using namespace std;

bool can_use(pair<int, int> &used, int color) {
    if (used.first == -1 || used.first == color) {
        used.first = color;
        return true;
    } else if (used.second == -1 || used.second == color) {
        used.second = color;
        return true;
    } else {
        return false;
    }
}

vector<vector<int>> one_solution(const vector<vector<int>> &g, const vector<int> &colors) {
    int n = g.size();
    vector<vector<int>> answer;
    vector<bool> used(n, false);
    vector<int> roots = {0};

    while (!roots.empty()) {
        int root = roots.back();
        roots.pop_back();
        auto used_col = make_pair(-1, -1);
        vector<int> dfs_stack = {root};
        answer.emplace_back();
        while (!dfs_stack.empty()) {
            int v = dfs_stack.back();
            dfs_stack.pop_back();

            used[v] = true;
            can_use(used_col, colors[v]);
            answer.back().push_back(v);

            for (int u : g[v]) {
                if (used[u]) {
                    continue;
                }
                if (can_use(used_col, colors[u])) {
                    dfs_stack.push_back(u);
                } else {
                    roots.push_back(u);
                }
            }
        }
    }

    return answer;
}

void solve() {
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

    int n;
    cin >> n;
    vector<int> colors(n);
    for (auto &c : colors) {
        cin >> c;
        c--;
    }
    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<vector<int>> answer(n);
    for (int i = 0; i < 15; i++) {
        auto res = one_solution(g, colors);
        if (res.size() < answer.size()) {
            answer = res;
        }
        for (int j = 0; j < n; j++) {
            shuffle(g[j].begin(), g[j].end(), rng);
        }
    }
    cout << answer.size() << "\n";
    for (auto &s : answer) {
        cout << s.size();
        for (int v : s) {
            cout << " " << v + 1;
        }
        cout << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}
