#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> col;
vector<int> dp0, dp1; // for root use dp0 only
vector<vector<int>> chosen0, chosen1; // children in the same set

vector<vector<int>> solve_for_compressed() {
    int n = g.size();
    dp0.resize(n, 0);
    dp1.resize(n, 0);
    chosen0.resize(n);
    chosen1.resize(n);


    function<void(int, int)> dfs = [&](int v, int p) {
        unordered_map<int, int> dp0_sums, best_sums;
        unordered_map<int, vector<int>> best_choices;
        int total_dp0 = 1;

        dp0[v] = 1;
        dp1[v] = 1;
        for (int u : g[v]) {
            if (u == p) {
                continue;
            }
            dfs(u, v);

            int cnt_best = min(dp0[u], dp1[u] - 1);
            bool taken_with = (cnt_best == dp1[u] - 1);
            // calc dp1
            if (col[u] == col[p]) {
                dp1[v] += cnt_best;
                if (taken_with) {
                    chosen1[v].push_back(u);
                }
            } else {
                dp1[v] += dp0[u];
            }
            // prepare for dp0
            total_dp0 += dp0[u];
            dp0_sums[col[u]] += dp0[u];
            best_sums[col[u]] += cnt_best;
            if (taken_with) {
                best_choices[col[u]].push_back(u);
            }
        }
        dp0[v] = total_dp0;
        int chosen_group = -1;
        for (auto group : best_sums) {
            int new_dp0 = total_dp0 - dp0_sums[group.first] + group.second;
            if (new_dp0 < dp0[v]) {
                chosen_group = group.first;
                dp0[v] = new_dp0;
            }
        }
        if (chosen_group != -1) {
            chosen0[v] = best_choices[chosen_group];
        }
    };

    dfs(0, 0);

    vector<vector<int>> answer(dp0[0]);
    vector<bool> used(n, false);
    int cnt_new_set = 0;

    function<void(int, int, int, int)> fill_sets = [&](int v, int p, int set_no, int dp_type) {
        if (used[v]) {
            return;
        }
        used[v] = true;
        answer[set_no].push_back(v);
        unordered_set<int> visited;

        if (dp_type == 0) {
            for (int u : chosen0[v]) {
                fill_sets(u, v, set_no, 1);
                visited.insert(u);
            }
        } else {
            for (int u : chosen1[v]) {
                fill_sets(u, v, set_no, 1);
                visited.insert(u);
            }
        }
        for (int u : g[v]) {
            if (u == p || visited.count(u) != 0) {
                continue;
            }
            cnt_new_set++;
            fill_sets(u, v, cnt_new_set, 0);
        }
    };
    fill_sets(0, 0, cnt_new_set, 0);
    return answer;
}

void solve() {
    int n;
    cin >> n;
    vector<int> colors(n);
    for (auto &c : colors) {
        cin >> c;
        c--;
    }
    vector<vector<int>> g_orig(n);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g_orig[u].push_back(v);
        g_orig[v].push_back(u);
    }
    // Compress graph into components
    vector<int> comp(n, -1);
    vector<vector<int>> comps;
    int cnt_v = 0;
    for (int i = 0; i < n; i++) {
        if (comp[i] != -1) {
            continue;
        }
        comps.emplace_back();
        vector<int> stack = {i};
        while (!stack.empty()) {
            int v = stack.back();
            stack.pop_back();
            comp[v] = cnt_v;
            comps.back().push_back(v);
            for (auto u : g_orig[v]) {
                if (colors[u] == colors[v] && comp[u] == -1) {
                    stack.push_back(u);
                }
            }
        }
        cnt_v++;
    }
    // Create new graph
    g.resize(cnt_v);
    col.resize(cnt_v);
    for (int i = 0; i < n; i++) {
        int v = comp[i];
        col[v] = colors[i];
        for (int j : g_orig[i]) {
            int u = comp[j];
            if (u != v) {
                g[u].push_back(v);
            }
        }
    }
    auto result = solve_for_compressed();
    cout << result.size() << "\n";
    for (auto &s : result) {
        vector<int> cnt_set;
        for (int s_i : s) {
            for (int v : comps[s_i]) {
                cnt_set.push_back(v);
            }
        }
        cout << cnt_set.size() << " ";
        for (auto v : cnt_set) {
            cout << v + 1 << " ";
        }
        cout << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}
