#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> col;
vector<int> dp0, dp1; // for root use dp0 only
vector<vector<int>> chosen0, chosen1; // children in the same set

void dfs(int v, int p) {
    vector<int> best_cnt_choices;
    vector<int> best_choises;
    best_cnt_choices.reserve(g[v].size());
    best_choises.reserve(g[v].size());

    int current_dp0_sum = 0, current_best_sum = 0;
    int processing_color = -1;
    int total_dp0 = 1;
    int best_delta = g.size() + 1;

    dp0[v] = 1;
    dp1[v] = 1;
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
        if (col[u] != processing_color && processing_color != -1) {
            // we've just finished all colors with the same color, update answer
            int delta = current_best_sum - current_dp0_sum;
            if (delta < best_delta) {
                best_delta = delta;
                best_choises = best_cnt_choices;
            }
        }
        if (col[u] != processing_color) {
            processing_color = col[u];
            best_cnt_choices.clear();
            current_dp0_sum = 0;
            current_best_sum = 0;
        }

        int cnt_best = min(dp0[u], dp1[u] - 1);
        bool taken_with = (cnt_best == dp1[u] - 1);
        // calc dp1
        if (col[u] == col[p]) {
            dp1[v] += cnt_best;
            if (taken_with) {
                chosen1[v].push_back(u);
            }
        } else {
            dp1[v] += dp0[u];
        }
        // prepare for dp0
        total_dp0 += dp0[u];
        current_dp0_sum += dp0[u];
        current_best_sum += cnt_best;
        if (taken_with) {
            best_cnt_choices.push_back(u);
        }
    }

    if (processing_color != -1) {
        // we've just finished last color, update answer
        int delta = current_best_sum - current_dp0_sum;
        if (delta < best_delta) {
            best_delta = delta;
            best_choises = best_cnt_choices;
        }
    }
    dp0[v] = total_dp0;
    if (best_delta < 0) {
        dp0[v] = total_dp0 + best_delta;
        chosen0[v] = best_choises;
    }
}

int cnt_new_set = 0;
vector<vector<int>> answer;

void fill_sets(int v, int p, int set_no, int dp_type, vector<bool> &used) {
    if (used[v]) {
        return;
    }
    used[v] = true;
    answer[set_no].push_back(v);

    if (dp_type == 0) {
        for (int u : chosen0[v]) {
            fill_sets(u, v, set_no, 1, used);
        }
    } else {
        for (int u : chosen1[v]) {
            fill_sets(u, v, set_no, 1, used);
        }
    }
    for (int u : g[v]) {
        if (u == p || used[u]) {
            continue;
        }
        cnt_new_set++;
        fill_sets(u, v, cnt_new_set, 0, used);
    }
}

vector<vector<int>> solve_for_compressed() {
    int n = g.size();
    dp0.resize(n, 0);
    dp1.resize(n, 0);
    chosen0.resize(n);
    chosen1.resize(n);

    for (int i = 0; i < n; i++) {
        sort(g[i].begin(), g[i].end(), [&](int v, int u) {
            return col[v] < col[u];
        });
    }

    dfs(0, 0);

    answer.resize(dp0[0]);
    vector<bool> used(n, false);

//    function<void(int, int, int, int)> fill_sets = [&](int v, int p, int set_no, int dp_type) {
//        if (used[v]) {
//            return;
//        }
//        used[v] = true;
//        answer[set_no].push_back(v);
//
//        if (dp_type == 0) {
//            for (int u : chosen0[v]) {
//                fill_sets(u, v, set_no, 1);
//            }
//        } else {
//            for (int u : chosen1[v]) {
//                fill_sets(u, v, set_no, 1);
//            }
//        }
//        for (int u : g[v]) {
//            if (u == p || used[u]) {
//                continue;
//            }
//            cnt_new_set++;
//            fill_sets(u, v, cnt_new_set, 0);
//        }
//    };
    fill_sets(0, 0, cnt_new_set, 0, used);
    return answer;
}

void solve() {
    int n;
    cin >> n;
    vector<int> colors(n);
    for (auto &c : colors) {
        cin >> c;
        c--;
    }
    vector<vector<int>> g_orig(n);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g_orig[u].push_back(v);
        g_orig[v].push_back(u);
    }
    // Compress graph into components
    vector<int> comp(n, -1);
    vector<vector<int>> comps;
    int cnt_v = 0;
    for (int i = 0; i < n; i++) {
        if (comp[i] != -1) {
            continue;
        }
        comps.emplace_back();
        vector<int> stack = {i};
        while (!stack.empty()) {
            int v = stack.back();
            stack.pop_back();
            comp[v] = cnt_v;
            comps.back().push_back(v);
            for (auto u : g_orig[v]) {
                if (colors[u] == colors[v] && comp[u] == -1) {
                    stack.push_back(u);
                }
            }
        }
        cnt_v++;
    }
    // Create new graph
    g.resize(cnt_v);
    col.resize(cnt_v);
    for (int i = 0; i < n; i++) {
        int v = comp[i];
        col[v] = colors[i];
        for (int j : g_orig[i]) {
            int u = comp[j];
            if (u != v) {
                g[u].push_back(v);
            }
        }
    }
    auto result = solve_for_compressed();
    cout << result.size() << "\n";
    for (auto &s : result) {
        vector<int> cnt_set;
        for (int s_i : s) {
            for (int v : comps[s_i]) {
                cnt_set.push_back(v);
            }
        }
        cout << cnt_set.size() << " ";
        for (auto v : cnt_set) {
            cout << v + 1 << " ";
        }
        cout << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}
