#include <bits/stdc++.h>
#include "testlib.h"
 
typedef long long ll;
 
using namespace std;
 
int n, w, total;
vector<int> a, p;
vector<vector<int>> sl;
 
void par(int v, int pred = -1){
    p[v] = pred;
    for(int u: sl[v]){
        if (u == pred) continue;
        par(u, v);
    }
}

int eval(int v, int pred, vector<vector<int>> &g){
    int res = a[v];
    for(int u: g[v]){
        if (u == pred) continue;
        res += eval(u, v, g);
    }
    return res;
}
 
bool readAndCheckAnswer(InStream& in) {
    int k = in.readInt(-1, n, "k");
    if(k == -1) return false;
    
    vector<int> d = in.readInts(k, 1, n, "d");
    in.ensuref(set<int>(d.begin(), d.end()).size() == d.size(), "all vertices must be different");
    vector<vector<int>> g(sl);
    
    if(count(d.begin(), d.end(), 1) > 0){
        if(total != w){
            in.quitf(_wa, "deleted weight=%d but %d required", total, w);
        }
        return true;
    }
    
    for(int e: d){
        e--;
        g[p[e]].erase(find(g[p[e]].begin(), g[p[e]].end(), e));
    }
    
    int res = eval(0, -1, g);
    if(total - res != w){
        in.quitf(_wa, "deleted weight=%d but %d required", total - res, w);
    }
    return true;
}
 
int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    n = inf.readInt();
    w = inf.readInt();
    a = inf.readInts(n);
    total = 0;
    for(int e: a) total += e;
    sl.assign(n, vector<int>(0));
    for(int i = 1; i < n; ++i){
        int u = inf.readInt();
        int v = inf.readInt();
        sl[--u].emplace_back(--v);
        sl[v].emplace_back(u);
    }
    p.assign(n, 0);
    par(0);
    
    bool ja = readAndCheckAnswer(ans);
    bool pa = readAndCheckAnswer(ouf);
    
    if(ja && !pa) quitf(_wa, "jury found answer but participant didn't");
    if(!ja && pa) quitf(_fail, "participant found answer but jury didn't");
 
    quitf(_ok, "success");
}
