#include "testlib.h"
#include <bits/stdc++.h>
 
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
 
typedef long long ll;
 
using namespace std;

struct dsu{
    vector<int> p, lvl;
 
    dsu(int n){
        p.resize(n);
        lvl.assign(n, 0);
        iota(all(p), 0);
    }
 
    int get(int i){
        if(i == p[i]) return i;
        return p[i] = get(p[i]);
    }
 
    bool unite(int a, int b){
        a = get(a);
        b = get(b);
        if(a == b){
            return false;
        }
        if(lvl[a] < lvl[b])swap(a, b);
        p[b] = a;
        if(lvl[a] == lvl[b]){
            ++lvl[a];
        }
        return true;
    }
};
 
int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    
    int n = inf.readInt(1, 1'000, "n");
    inf.readSpace();
    inf.readInt(1, 1'000, "w");
    inf.readEoln();
    
    inf.readInts(n, 1, 100, "a");
    inf.readEoln();
    
    dsu tree(n + 1);
    for(int i = 1; i < n; ++i){
        int u = inf.readInt(1, n, "u");
        inf.readSpace();
        int v = inf.readInt(1, n, "v");
        inf.readEoln();
        ensuref(tree.unite(u, v), "the %d-th edge is multiple or creates cycle", i);
    }
    
    inf.readEof();
}
